diff -c gcc-3.3.2-orig-gcc/real.h gcc-3.3.2-patched-gcc/real.h
*** gcc-3.3.2-orig-gcc/real.h	Tue Jul  1 21:28:45 2003
--- gcc-3.3.2-patched-gcc/real.h	Sat Feb  7 21:33:06 2004
***************
*** 40,52 ****
  #define SIGSZ			(SIGNIFICAND_BITS / HOST_BITS_PER_LONG)
  #define SIG_MSB			((unsigned long)1 << (HOST_BITS_PER_LONG - 1))
  
  struct real_value GTY(())
  {
!   ENUM_BITFIELD (real_value_class) class : 2;
    unsigned int sign : 1;
    signed int exp : EXP_BITS;
    unsigned long sig[SIGSZ];
  };
  
  /* Various headers condition prototypes on #ifdef REAL_VALUE_TYPE, so it
     needs to be a macro.  We do need to continue to have a structure tag
--- 40,62 ----
  #define SIGSZ			(SIGNIFICAND_BITS / HOST_BITS_PER_LONG)
  #define SIG_MSB			((unsigned long)1 << (HOST_BITS_PER_LONG - 1))
  
+ /* Can't have "class" in C++, but gentype gets confused on #ifdefs
+    within the struct. */
+ #ifndef __cplusplus
+ # define REAL_CLASSY class
+ #else
+ # define REAL_CLASSY cl
+ #endif
+ 
  struct real_value GTY(())
  {
!   ENUM_BITFIELD (real_value_class) REAL_CLASSY : 2;
    unsigned int sign : 1;
    signed int exp : EXP_BITS;
    unsigned long sig[SIGSZ];
  };
+ 
+ #undef REAL_CLASSY
  
  /* Various headers condition prototypes on #ifdef REAL_VALUE_TYPE, so it
     needs to be a macro.  We do need to continue to have a structure tag
diff -c gcc-3.3.2-orig-gcc/rtl.h gcc-3.3.2-patched-gcc/rtl.h
*** gcc-3.3.2-orig-gcc/rtl.h	Thu May  1 21:21:07 2003
--- gcc-3.3.2-patched-gcc/rtl.h	Sat Feb  7 21:33:36 2004
***************
*** 111,118 ****
--- 111,123 ----
    int rtint;
    unsigned int rtuint;
    const char *rtstr;
+ #ifndef __cplusplus
    rtx rtx;
    rtvec rtvec;
+ #else
+   rtx rt_rtx;
+   rtvec rt_vec;
+ #endif
    enum machine_mode rttype;
    addr_diff_vec_flags rt_addr_diff_vec_flags;
    struct cselib_val_struct *rt_cselib;
*** gcc-orig/config/rs6000/rs6000.c	Wed Jan 14 09:03:58 2004
--- gcc/config/rs6000/rs6000.c	Sat May 21 16:06:49 2005
***************
*** 387,396 ****
  
  /* ??? Should work everywhere, but ask dje@watson.ibm.com before
     enabling for AIX.  */
! #if TARGET_OBJECT_FORMAT != OBJECT_XCOFF
  #undef TARGET_ASM_CAN_OUTPUT_MI_THUNK
  #define TARGET_ASM_CAN_OUTPUT_MI_THUNK default_can_output_mi_thunk_no_vcall
! #endif
  
  struct gcc_target targetm = TARGET_INITIALIZER;
  
--- 387,396 ----
  
  /* ??? Should work everywhere, but ask dje@watson.ibm.com before
     enabling for AIX.  */
! /*#if TARGET_OBJECT_FORMAT != OBJECT_XCOFF*//*enabled for gdc*/
  #undef TARGET_ASM_CAN_OUTPUT_MI_THUNK
  #define TARGET_ASM_CAN_OUTPUT_MI_THUNK default_can_output_mi_thunk_no_vcall
! /*#endif*/
  
  struct gcc_target targetm = TARGET_INITIALIZER;
  
***************
*** 11193,11199 ****
           although IBM appears to be using 13.  There is no official value
  	 for Chill, so we've chosen 44 pseudo-randomly.  */
        if (! strcmp (language_string, "GNU C")
! 	  || ! strcmp (language_string, "GNU Objective-C"))
  	i = 0;
        else if (! strcmp (language_string, "GNU F77"))
  	i = 1;
--- 11193,11200 ----
           although IBM appears to be using 13.  There is no official value
  	 for Chill, so we've chosen 44 pseudo-randomly.  */
        if (! strcmp (language_string, "GNU C")
! 	  || ! strcmp (language_string, "GNU Objective-C")
! 	  || ! strcmp (language_string, "GNU D"))
  	i = 0;
        else if (! strcmp (language_string, "GNU F77"))
  	i = 1;
