diff -c gcc-gcc-3.4.0-orig/real.h gcc-gcc-3.4.0/real.h
*** gcc-gcc-3.4.0-orig/real.h	Fri Oct 10 20:33:05 2003
--- gcc-gcc-3.4.0/real.h	Mon Sep 27 14:06:40 2004
***************
*** 40,48 ****
  #define SIGSZ			(SIGNIFICAND_BITS / HOST_BITS_PER_LONG)
  #define SIG_MSB			((unsigned long)1 << (HOST_BITS_PER_LONG - 1))
  
  struct real_value GTY(())
  {
!   ENUM_BITFIELD (real_value_class) class : 2;
    unsigned int sign : 1;
    unsigned int signalling : 1;
    unsigned int canonical : 1;
--- 40,56 ----
  #define SIGSZ			(SIGNIFICAND_BITS / HOST_BITS_PER_LONG)
  #define SIG_MSB			((unsigned long)1 << (HOST_BITS_PER_LONG - 1))
  
+ /* Can't have "class" in C++, but gentype gets confused on #ifdefs
+    within the struct. */
+ #ifndef __cplusplus
+ # define REAL_CLASSY class
+ #else
+ # define REAL_CLASSY cl
+ #endif
+ 
  struct real_value GTY(())
  {
!   ENUM_BITFIELD (real_value_class) REAL_CLASSY : 2;
    unsigned int sign : 1;
    unsigned int signalling : 1;
    unsigned int canonical : 1;
***************
*** 50,55 ****
--- 58,65 ----
    unsigned long sig[SIGSZ];
  };
  
+ #undef REAL_CLASSY
+ 
  /* Various headers condition prototypes on #ifdef REAL_VALUE_TYPE, so it
     needs to be a macro.  We do need to continue to have a structure tag
     so that other headers can forward declare it.  */
diff -c gcc-gcc-3.4.0-orig/rtl.h gcc-gcc-3.4.0/rtl.h
*** gcc-gcc-3.4.0-orig/rtl.h	Thu Mar 25 16:44:43 2004
--- gcc-gcc-3.4.0/rtl.h	Mon Sep 27 14:06:40 2004
***************
*** 121,128 ****
--- 121,133 ----
    int rtint;
    unsigned int rtuint;
    const char *rtstr;
+ #ifndef __cplusplus
    rtx rtx;
    rtvec rtvec;
+ #else
+   rtx rt_rtx;
+   rtvec rt_vec;
+ #endif
    enum machine_mode rttype;
    addr_diff_vec_flags rt_addr_diff_vec_flags;
    struct cselib_val_struct *rt_cselib;
*** gcc-orig/libgcc2.c	Sun Sep 26 16:47:14 2004
--- gcc/libgcc2.c	Sat May  7 11:47:55 2005
***************
*** 29,34 ****
--- 29,45 ----
  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.  */
  
+ #ifdef L_eprintf
+ #ifdef __APPLE__
+ /* Hack for MacOS 10.4: gcc 3.4.x uses -mlong-double-128 to build
+    libgcc.  On 10.4, this causes *printf to be defined as
+    *printf$LDBLStub and requires linking with libSystemStubs.  Prevent
+    this from happening by making it seem as though double is the same
+    as long double. */
+ #undef  __LDBL_MANT_DIG__
+ #define __LDBL_MANT_DIG__ __DBL_MANT_DIG__
+ #endif
+ #endif
  
  /* We include auto-host.h here to get HAVE_GAS_HIDDEN.  This is
     supposedly valid even though this is a "target" file.  */
*** gcc-orig/config/rs6000/rs6000.c	Fri Oct 22 15:19:35 2004
--- gcc/config/rs6000/rs6000.c	Sat May 21 16:08:37 2005
***************
*** 12973,12979 ****
  	 use language_string.
  	 C is 0.  Fortran is 1.  Pascal is 2.  Ada is 3.  C++ is 9.
  	 Java is 13.  Objective-C is 14.  */
!       if (! strcmp (language_string, "GNU C"))
  	i = 0;
        else if (! strcmp (language_string, "GNU F77"))
  	i = 1;
--- 12973,12980 ----
  	 use language_string.
  	 C is 0.  Fortran is 1.  Pascal is 2.  Ada is 3.  C++ is 9.
  	 Java is 13.  Objective-C is 14.  */
!       if (! strcmp (language_string, "GNU C") ||
! 	  ! strcmp (language_string, "GNU D"))
  	i = 0;
        else if (! strcmp (language_string, "GNU F77"))
  	i = 1;
